<template>
  <div class="mod-config">
    <basic-container>
      <ttable
        :table="table"
        @handleSelectionChange="handleSelectionChange"
        :uploadInfo="uploadInfo"
        :prelang="prelang"
        :options="options"
        :ajaxFun="ajaxFun"
        :paramObj="paramObj"
        :bottomOffset="125"
        ref="escortTable"
      >
        <template #toolbar>
           <el-button
            v-for="item in toolbar"
            :key="item.text"
            :disabled="item.disabled"
            :type="item.type"
            :v-if="item.isShow"
            @click="handleCommand(item.ref)"
            >{{ item.text }}
          </el-button>

          <el-button
            @click="exportPageButton.fun"
            :type="exportPageButton.type"
            v-if="exportPageButton.isShow"
            :loading="exportPageButton.loading"
            >{{ exportPageButton.text }}
          </el-button>



        </template>
      </ttable>
    </basic-container>
    <!-- 退货 -->
    <table-form
      v-if="addOrUpdateVisible"
      ref="addOrUpdate"
      @refreshDataList="getData"
      :sendBackList="multipleSelection"
    ></table-form>

    <!-- 退货明细 -->
    <escort-dialog
      v-if="escortVisible"
      ref="escortUpdate"
      @refreshDataList="getData"
    ></escort-dialog>
    <!-- 弹窗, 新增 / 修改 -->
  </div>
</template>

<script>
import { transform } from '@/util/fileTransform'
import ttable from '@/views/common/ztt-table.vue'
import { mapGetters } from 'vuex'
import { getEscortDetailListComplete,exportSendBackRecord } from '../../../api/warehouse/escort'
import TableForm from './sendback-form'
import EscortDialog from './escort'
export default {
  data() {
    return {
       exportPageButton: {
        text: '导出',
        type: 'primary',
        isShow: true,
        fun: this.exportPage,
        loading: false
      },

      escortVisible: false,
      paramObj: { status: '02completed' },
      innerVisible: false,
      ajaxFun: getEscortDetailListComplete,
      multipleSelection: [],
      uploadInfo: {
        // 是否展示上传EXCEL以及对应的url
        isShow: false,
        url: ''
      },
      prelang: 'operation',
      options: {
        height: 300, // 默认高度-为了表头固定
        stripe: true, // 是否为斑马纹 table
        highlightCurrentRow: false, // 是否要高亮当前行
        border: true, // 是否有纵向边框
        lazy: false, // 是否需要懒加载
        fit: true, // 列的宽度是否自撑开
        multiSelect: true, //
        seqNo: true,
        isRefresh: true, // 是否显示刷新按钮
        isShowHide: true, // 是否显示显影按钮
        isSearch: false, // 高级查询按钮
        defaultOrderBy: { column: 'id', direction: 'desc' }
      },
      table: {
        total: 0,
        currentPage: 1,
        pageSize: 20,
        data: [],
        column: [
          {
            minWidth: '140',
            prop: 'escortNo',
            label: '押运单号',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          {
            minWidth: '120',
            prop: 'status',
            label: '押运单状态',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'select',
            formatter: this.formatStatus,
            optList: () => {
              return this.statusOptions
            }
          },
          {
            minWidth: '120',
            prop: 'customerOrderNo',
            label: '客户订单号',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          {
            minWidth: '120',
            prop: 'customerName',
            label: '客户名称',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          {
            minWidth: '120',
            prop: 'partBatchNo',
            label: '零件批号',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          {
            minWidth: '120',
            prop: 'partNo',
            label: '零件编号',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          {
            minWidth: '200',
            prop: 'partName',
            label: '零件名称',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          {
            minWidth: '120',
            prop: 'deliveryQty',
            label: '本次发货数量',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          {
            minWidth: '120',
            prop: 'reservedQuantity',
            label: '预留数量',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          {
            minWidth: '120',
            prop: 'deliveredQuantity',
            label: '已发货数量',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          {
            minWidth: '120',
            prop: 'sendBackQuantity',
            label: '退货数量',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          }
         
           ,{
            minWidth: '120',
            prop: 'logisticsCompany',
            label: '物流公司',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          }
          ,{
            minWidth: '120',
            prop: 'deliveryTime',
            label: '发货时间',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          }
          ,{
            minWidth: '120',
            prop: 'contractNo',
            label: '合同号',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          }
          ,{
            minWidth: '120',
            prop: 'customer',
            label: '客户',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          }
          ,{
            minWidth: '120',
            prop: 'entityName',
            label: '工程名称',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          }
          ,{
            minWidth: '120',
            prop: 'deliveryLength',
            label: '发货长度',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          }
          ,{
            minWidth: '120',
            prop: 'netWeight',
            label: '发货净重',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          }
          ,{
            minWidth: '120',
            prop: 'grossWeight',
            label: '发货毛重',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          }
           ,{
            minWidth: '120',
            prop: 'companyName',
            label: '公司名称',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          }
           ,{
            minWidth: '120',
            prop: 'contactPerson',
            label: '联系人',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          }
           ,{
            minWidth: '120',
            prop: 'telephone',
            label: '电话',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          }
           ,{
            minWidth: '120',
            prop: 'deliveryAddress',
            label: '交货地址',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          }
           ,{
            minWidth: '120',
            prop: 'remark',
            label: '发货备注',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          }
        ],
        toolbar: [
          {
            text: '退货',
            type: 'primary',
            fun: this.sendBack
          }

        ],
        operator: [
          {
            text: '退货明细',
            type: 'text',
            size: 'small',
            fun: this.getSendBack
          }
        ],
        operatorConfig: {
          fixed: 'right',
          label: '操作',
          width: 100,
          minWidth: 100
        }
      },
      addOrUpdateVisible: false,
      statusOptions: [
        {
          value: '01draft',
          label: '草稿',
          colorLabel: '<span style="color:red">草稿</span>'
        },
        {
          value: '02completed',
          label: '已完成',
          colorLabel: '已完成'
        }
      ]
    }
  },
  components: {
    ttable,
    TableForm,
    EscortDialog
  },
  computed: {
    ...mapGetters(['permissions'])
  },
  methods: {
    // 导出
    exportPage() {
      this.exportPageButton.loading = true
      exportSendBackRecord(this.$refs.escortTable.getQueryParam())
        .then((response) => {
          transform(response)
          this.exportPageButton.loading = false
        })
        .catch(() => {
          this.exportPageButton.loading = false
        })
    },
    // 获取数据列表
    getData() {
      if (this.$refs.escortTable !== undefined) {
        this.$refs.escortTable.getDataList()
      }
    },
    handleSelectionChange(val) {
      this.multipleSelection = val
    },
    formatDate(row, column, cellValue) {
      if (cellValue) {
        const dutyDateList = /\d{4}-\d{1,2}-\d{1,2}/g.exec(cellValue)
        if (dutyDateList && dutyDateList.length > 0) {
          return dutyDateList[0]
        }
      }
      return ''
    },
    sendBack() {
      if (this.multipleSelection && this.multipleSelection.length   == 1  ) {
        this.addOrUpdateVisible = true
        this.$nextTick(() => {
          this.$refs.addOrUpdate.init(this.multipleSelection)
        })
      } else {
        this.$message.error('请选择一条已完成的发货明细')
      }
    },
    getSendBack(row) {
      this.escortVisible = true
      this.$nextTick(() => {
        this.$refs.escortUpdate.init(row.id)
      })
    },
    formatStatus(row, column, cellValue) {
      this.statusOptions.forEach((obj) => {
        if (obj.value === cellValue) {
          cellValue = obj.colorLabel
        }
      })
      return cellValue
    }
  }
}
</script>
